ns {splines} | R Documentation

## Generate a Basis Matrix for Natural Cubic Splines

### Description

Generate the B-spline basis matrix for a natural cubic spline.

### Usage

    ns(x, df = NULL, knots = NULL, intercept = FALSE,
       Boundary.knots = range(x))

### Arguments

`x` | the predictor variable. Missing values are allowed.
`df` | degrees of freedom. One can supply `df` rather than knots; `ns()` then chooses `df - 1 - intercept` knots at suitably chosen quantiles of `x` (which will ignore missing values).
`knots` | breakpoints that define the spline. The default is no knots; together with the natural boundary conditions this results in a basis for linear regression on `x`. Typical values are the mean or median for one knot, quantiles for more knots. See also `Boundary.knots`.
`intercept` | if `TRUE`, an intercept is included in the basis; default is `FALSE`.
`Boundary.knots` | boundary points at which to impose the natural boundary conditions and anchor the B-spline basis (default the range of the data). If both `knots` and `Boundary.knots` are supplied, the basis parameters do not depend on `x`. Data can extend beyond `Boundary.knots`

### Value

A matrix of dimension `length(x) * df` where either `df` was supplied or if `knots` were supplied, `df = length(knots) + 1 + intercept`. Attributes are returned that correspond to the arguments to `ns`, and explicitly give the `knots`, `Boundary.knots` etc for use by `predict.ns()`.

`ns()` is based on the function `spline.des`. It generates a basis matrix for representing the family of piecewise-cubic splines with the specified sequence of interior knots, and the natural boundary conditions. These enforce the constraint that the function is linear beyond the boundary knots, which can either be supplied, else default to the extremes of the data. A primary use is in modeling formula to directly specify a natural spline term in a model.

### References

Hastie, T. J. (1992) Generalized additive models. Chapter 7 of Statistical Models in S eds J. M. Chambers and T. J. Hastie, Wadsworth & Brooks/Cole.

### See Also

`bs`, `predict.ns`, `SafePrediction`

### Examples

    require(stats); require(graphics)
    ns(women$height, df = 5)
    summary(fm1 <- lm(weight ~ ns(height, df = 5), data = women))

    ## example of safe prediction
    plot(women, xlab = "Height (in)", ylab = "Weight (lb)")
    ht <- seq(57, 73, length.out = 200)
    lines(ht, predict(fm1, data.frame(height=ht)))

[Package splines version 2.15.1 Index]